/*
 *  Disc.cpp
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Disc.h"

Disc::Disc(Material *newMaterial, const Point &newCenter, const Vector &newNormal, double newRadius) : Primitive(newMaterial), center(newCenter), normalVector(newNormal), radius(newRadius) {
	normalVector.normalize();
	d = dot(normalVector, center);
	radiusSquared = radius * radius;
}

bool Disc::intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	double denom = dot(normalVector, ray.getDirection());
	
	if (denom < VERY_SMALL && denom > -VERY_SMALL)
		return false;
	else
	{
		// numer = d + plane.normal dot ray.origin
		double numer = dot(normalVector, ray.getOrigin());
		numer = d - numer;
		double t = (numer/denom);
		//		double t = 30.0;
		
		// P = O + tV
		Point hitPoint = ray.getOrigin() + ray.getDirection() * t;
		// D = P - C
		Vector hitRadius = hitPoint - center;
		if (dot(hitRadius, hitRadius) < radiusSquared)
		{
			hit.hit(t, this, material);
			return true;
		}
		return false;
	}
}


void Disc::normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	normal = normalVector;
}
