/*
 *  OrthographicCamera.h
 *  Assignment2-2
 *
 *  Created by Zach Gildersleeve on 2/3/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef ORTHOGRAPHICCAMERA_H
#define ORTHOGRAPHICCAMERA_H

#include "Camera.h"
#include "Point.h"
#include "Vector.h"
#include "Ray.h"

class RenderContext;

class OrthographicCamera : public Camera {
	public:
	OrthographicCamera(const Point &newPosition, const Vector &newU, const Vector &newV) : position(newPosition), u(newU), v(newV) {}
	~OrthographicCamera() {}
	
	virtual void preprocess(double aspectRatio);
	virtual void makeRay(Ray &ray, const RenderContext &context, double x, double y) const;
	
	private:
		Point position;
		Vector u;
		Vector v;
		Vector normal;
	
};




#endif